
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
	.global	ppu_grayscale_table
	.code
	.align	2
ppu_grayscale_table:
	.byte	21
	.byte	33
	.byte	37
	.byte	36
	.byte	32
	.byte	31
	.byte	32
	.byte	33
	.byte	33
	.byte	35
	.byte	35
	.byte	34
	.byte	34
	.byte	42
	.byte	41
	.byte	41
	.byte	9
	.byte	26
	.byte	27
	.byte	26
	.byte	23
	.byte	24
	.byte	26
	.byte	27
	.byte	23
	.byte	27
	.byte	28
	.byte	27
	.byte	23
	.byte	37
	.byte	41
	.byte	41
	.byte	0
	.byte	16
	.byte	16
	.byte	14
	.byte	18
	.byte	17
	.byte	15
	.byte	14
	.byte	11
	.byte	12
	.byte	16
	.byte	15
	.byte	13
	.byte	27
	.byte	40
	.byte	40
	.byte	0
	.byte	5
	.byte	6
	.byte	10
	.byte	9
	.byte	10
	.byte	6
	.byte	3
	.byte	3
	.byte	6
	.byte	8
	.byte	7
	.byte	5
	.byte	6
	.byte	39
	.byte	39
	.code
	.align	1
	.global	ppu_reset
ppu_reset:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ld.w	%r0,%r12
	ext	ppu+0x0@h	; 	xld.w	%r12,ppu
	ext	ppu+0x0@m
	ld.w	%r12,ppu+0x0@l
	ld.w	%r13,0x0
	ext	0x0		; 	xld.w	%r14,0x00000030		; 48
	ld.w	%r14,0x30
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	ext	ppu+0x8@ah	; 	xld.b	[ppu+8],%r0
	ext	ppu+0x8@al
	ld.b	[%r8],%r0
	popn	%r0
	ret
	.align	1
	.global	ppu_read
ppu_read:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu+0x0@h	; 	xld.w	%r13,ppu
	ext	ppu+0x0@m
	ld.w	%r13,ppu+0x0@l
	and	%r12,0x7	; 	xand	%r12,%r12,0x00000007
	cmp	%r12,0x2	; 	xcmp	%r12,2
	jreq	__LX31		; 	xjreq	__L31
	cmp	%r12,0x7	; 	xcmp	%r12,7
	jreq	__LX32		; 	xjreq	__L32
	jp	__LX35		; 	xjp	__L35
__LX31:				; __L31:
	ext	ppu+0x2@ah	; 	xld.ub	%r12,[ppu+2]
	ext	ppu+0x2@al
	ld.ub	%r12,[%r8]
	jp	__LX30		; 	xjp	__L30
__LX32:				; __L32:
	ext	ppu+0x9@ah	; 	xld.ub	%r12,[ppu+9]
	ext	ppu+0x9@al
	ld.ub	%r12,[%r8]
	ext	ppu+0x6@ah	; 	xld.uh	%r11,[ppu+6]
	ext	ppu+0x6@al
	ld.uh	%r11,[%r8]
	ld.w	%r10,%r11
	ext	0xff		; 	xand	%r10,%r10,0x00003fff
	and	%r10,0x3f
	ext	ppu_vram+0x0@h	; 	xld.ub	%r10,[%r10+ppu_vram]
	ext	ppu_vram+0x0@m
	ld.w	%r9,ppu_vram+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ext	ppu+0x9@ah	; 	xld.b	[ppu+9],%r10
	ext	ppu+0x9@al
	ld.b	[%r8],%r10
	ld.uh	%r11,%r11
	btst	[%r13],0x2	; 	xbtst	[%r13],0x2
	jreq	__LX33		; 	xjreq	__L33
	ext	0x20		; 	xadd	%r10,%r11,32
	add	%r10,%r11
	jp	__LX34		; 	xjp	__L34
__LX33:				; __L33:
	ext	0x1		; 	xadd	%r10,%r11,1
	add	%r10,%r11
__LX34:				; __L34:
	ext	0x6		; 	xld.h	[%r13+6],%r10
	ld.h	[%r13],%r10
	jp	__LX30		; 	xjp	__L30
__LX35:				; __L35:
	ld.w	%r12,0x0
__LX30:				; __L30:
	ld.w	%r10,%r12
	ret
	.align	1
	.global	ppu_write
ppu_write:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ext	ppu+0x0@h	; 	xld.w	%r0,ppu
	ext	ppu+0x0@m
	ld.w	%r0,ppu+0x0@l
	ld.w	%r10,%r12
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	cmp	%r10,0x7	; 	xcmp	%r10,7
	jrugt	__L38		; 	xjrugt	__L38
	sll	%r10,0x2	; 	xsll	%r10,2
	ext	__L48+0x0@h	; 	xld.w	%r10,[%r10+__L48]
	ext	__L48+0x0@m
	ld.w	%r9,__L48+0x0@l
	add	%r9,%r10
	ld.w	%r10,[%r9]
	jp	%r10
	.code
	.align	2
__L48:
	.word	__L39
	.word	__L40
	.word	__L38
	.word	__L41
	.word	__L42
	.word	__L43
	.word	__L44
	.word	__L45
	.code
__L39:
	ld.b	[%r0],%r13	; 	xld.b	[%r0],%r13
	jp	__L38		; 	xjp	__L38
__L40:
	ext	0x1		; 	xld.b	[%r0+1],%r13
	ld.b	[%r0],%r13
	jp	__L38		; 	xjp	__L38
__L41:
	ext	0x3		; 	xld.b	[%r0+3],%r13
	ld.b	[%r0],%r13
	jp	__L38		; 	xjp	__L38
__L42:
	ext	0x3		; 	xld.ub	%r10,[%r0+3]
	ld.ub	%r10,[%r0]
	ext	0x1		; 	xadd	%r11,%r10,1
	add	%r11,%r10
	ext	0x3		; 	xld.b	[%r0+3],%r11
	ld.b	[%r0],%r11
	ld.ub	%r10,%r10
	ext	ppu_sprram+0x0@h	; 	xld.b	[%r10+ppu_sprram],%r13
	ext	ppu_sprram+0x0@m
	ld.w	%r9,ppu_sprram+0x0@l
	add	%r9,%r10
	ld.b	[%r9],%r13
	jp	__L38		; 	xjp	__L38
__L43:
	ext	0x4		; 	xld.uh	%r10,[%r0+4]
	ld.uh	%r10,[%r0]
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r10,%r13
	ext	0x4		; 	xld.h	[%r0+4],%r10
	ld.h	[%r0],%r10
	jp	__L38		; 	xjp	__L38
__L44:
	ext	0x6		; 	xld.uh	%r10,[%r0+6]
	ld.uh	%r10,[%r0]
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r10,%r13
	jp	__LX47		; 	xjp	__L47
__L45:
	ext	0x6		; 	xld.uh	%r12,[%r0+6]
	ld.uh	%r12,[%r0]
	ext	0xff		; 	xand	%r12,%r12,0x00003fff
	and	%r12,0x3f
	ext	ppu_vram_write@rm	; 	xcall	ppu_vram_write
	call	ppu_vram_write@rl
	ext	0x6		; 	xld.uh	%r11,[%r0+6]
	ld.uh	%r11,[%r0]
	btst	[%r0],0x2	; 	xbtst	[%r0],0x2
	jreq	__LX46		; 	xjreq	__L46
	ext	0x20		; 	xadd	%r10,%r11,32
	add	%r10,%r11
	jp	__LX47		; 	xjp	__L47
__LX46:				; __L46:
	ext	0x1		; 	xadd	%r10,%r11,1
	add	%r10,%r11
__LX47:				; __L47:
	ext	0x6		; 	xld.h	[%r0+6],%r10
	ld.h	[%r0],%r10
__L38:
	popn	%r0
	ret
	.align	1
	.global	ppu_update
ppu_update:
;	.frame	%sp,20,$31		# vars= 4, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r15,%r12
	ext	ppu+0x0@h	; 	xld.w	%r2,ppu
	ext	ppu+0x0@m
	ld.w	%r2,ppu+0x0@l
	ext	ppu_vram+0x0@h	; 	xld.w	%r10,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r10,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r14,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r14,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	cmp	%r15,0x0
	jreq	__LX51		; 	xjreq	__L51
	cmp	%r1,0x0
	jreq	__LX51		; 	xjreq	__L51
	ext	ppu+0xc@ah	; 	xld.w	[ppu+12],%r15
	ext	ppu+0xc@al
	ld.w	[%r8],%r15
	ext	0x1		; 	xadd	%r12,%r10,16128
	ext	0x1f00
	add	%r12,%r10
	ext	0x10		; 	xadd	%r11,%r2,16
	add	%r11,%r2
	ext	0x0		; 	xld.w	%r0,0x00000020		; 32
	ld.w	%r0,0x20
	ext	0x0		; 	xld.w	%r13,0x0000003f		; 63
	ld.w	%r13,0x3f
__LX52:				; __L52:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,%r13
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	ext	ppu_grayscale_table+0x0@h	; 	xld.ub	%r10,[%r10+ppu_grayscale_table]
	ext	ppu_grayscale_table+0x0@m
	ld.w	%r9,ppu_grayscale_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	add	%r11,0x1	; 	xadd	%r11,%r11,1
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
	jrne	__LX52		; 	xjrne	__L52
	ld.w	%r12,%r14
	sll	%r12,0x8	; 	xsll	%r12,8
	ext	0x10		; 	xld.ub	%r13,[%r2+16]
	ld.ub	%r13,[%r2]
	ld.w	%r4,%r1
	sub	%r4,%r14
	ld.w	%r14,%r4
	add	%r15,%r12
	ld.w	%r12,%r15
	sll	%r14,0x8	; 	xsll	%r14,8
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	ext	0x1		; 	xbtst	[%r2+1],0x4
	btst	[%r2],0x4
	jreq	__LX56		; 	xjreq	__L56
	ld.w	%r12,0x1	; 	xld.w	%r12,0x00000001		; 1
	ext	ppu_draw_sprite@rm	; 	xcall	ppu_draw_sprite
	call	ppu_draw_sprite@rl
__LX56:				; __L56:
	ext	0x1		; 	xbtst	[%r2+1],0x3
	btst	[%r2],0x3
	jreq	__LX57		; 	xjreq	__L57
	ext	ppu_draw_bg@rm	; 	xcall	ppu_draw_bg
	call	ppu_draw_bg@rl
__LX57:				; __L57:
	ext	0x1		; 	xbtst	[%r2+1],0x4
	btst	[%r2],0x4
	jreq	__LX51		; 	xjreq	__L51
	ld.w	%r12,%r0
	ext	ppu_draw_sprite@rm	; 	xcall	ppu_draw_sprite
	call	ppu_draw_sprite@rl
__LX51:				; __L51:
	ld.w	%r14,%r1
	ext	0xa		; 	xld.b	[%r2+10],%r1
	ld.b	[%r2],%r1
	ext	0x3		; 	xld.w	%r13,0x000000ef		; 239
	ld.w	%r13,0x2f
	cmp	%r1,%r13
	jrgt	__LX59		; 	xjrgt	__L59
	cmp	%r1,0x0
	jrne	__LX60		; 	xjrne	__L60
	ext	0x2		; 	xld.ub	%r10,[%r2+2]
	ld.ub	%r10,[%r2]
	ext	0x0		; 	xand	%r10,%r10,0x0000003f
	and	%r10,0x3f
	ext	0x2		; 	xld.b	[%r2+2],%r10
	ld.b	[%r2],%r10
__LX60:				; __L60:
	ext	0x2		; 	xld.ub	%r12,[%r2+2]
	ld.ub	%r12,[%r2]
	ext	0x1		; 	xld.w	%r11,0x00000040		; 64
	ld.w	%r11,0x0
	ld.w	%r10,%r12
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	jrne	__LX61		; 	xjrne	__L61
	ext	ppu_sprram+0x0@ah	; 	xld.ub	%r10,[ppu_sprram]
	ext	ppu_sprram+0x0@al
	ld.ub	%r10,[%r8]
	add	%r10,0x1	; 	xadd	%r10,%r10,1
	ld.ub	%r10,%r10
	cmp	%r10,%r13
	jrle	__LX62		; 	xjrle	__L62
	ld.b	%r10,%r10
__LX62:				; __L62:
	cmp	%r1,%r10
	jrge	__LX63		; 	xjrge	__L63
	ld.w	%r1,%r10
	jp	__LX65		; 	xjp	__L65
__LX63:				; __L63:
	ld.w	%r10,%r12
	or	%r10,%r11
	ext	0x2		; 	xld.b	[%r2+2],%r10
	ld.b	[%r2],%r10
__LX61:				; __L61:
	ext	0x3		; 	xld.w	%r1,0x000000f0		; 240
	ld.w	%r1,0x30
__LX65:				; __L65:
	ext	0xb		; 	xld.b	[%r2+11],%r1
	ld.b	[%r2],%r1
	jp	__LX66		; 	xjp	__L66
__LX59:				; __L59:
	ext	0x2		; 	xld.w	%r11,0x00000080		; 128
	ld.w	%r11,0x0
	ld.w	%r10,%r11
	ext	0x2		; 	xld.ub	%r4,[%r2+2]
	ld.ub	%r4,[%r2]
	or	%r10,%r4
	ext	0x2		; 	xld.b	[%r2+2],%r10
	ld.b	[%r2],%r10
	ld.w	%r10,%r11
	ld.ub	%r4,[%r2]	; 	xld.ub	%r4,[%r2]
	and	%r10,%r4
	ld.ub	%r10,%r10
	cmp	%r10,0x0
	jreq	__LX67		; 	xjreq	__L67
	ld.w	%r10,%r11
	ext	0x8		; 	xld.ub	%r4,[%r2+8]
	ld.ub	%r4,[%r2]
	or	%r10,%r4
	ext	0x8		; 	xld.b	[%r2+8],%r10
	ld.b	[%r2],%r10
__LX67:				; __L67:
	ext	0x4		; 	xld.w	%r1,0x00000106		; 262
	ld.w	%r1,0x6
	ld.w	%r4,0x0
	ext	0xb		; 	xld.b	[%r2+11],%r4
	ld.b	[%r2],%r4
__LX66:				; __L66:
	ld.w	%r11,%r1
	sub	%r11,%r14
	ext	0x3		; 	xld.w	%r10,0x000000e4		; 228
	ld.w	%r10,0x24
	mlt.w	%r11,%r10
	ld.w	%r10,%alr
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r2
	ret
	.align	1
	.global	ppu_vram_write
ppu_vram_write:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	0x7f		; 	xcmp	%r12,8191
	cmp	%r12,0x3f
	jrgt	__LX69		; 	xjrgt	__L69
	ld.w	%r10,%r12
	add	%r10,%r11
	jp	__LX83		; 	xjp	__L83
__LX69:				; __L69:
	ext	0xbf		; 	xcmp	%r12,12287
	cmp	%r12,0x3f
	jrgt	__LX71		; 	xjrgt	__L71
	ext	ppu+0x8@ah	; 	xld.ub	%r10,[ppu+8]
	ext	ppu+0x8@al
	ld.ub	%r10,[%r8]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX72		; 	xjreq	__L72
	ld.w	%r10,%r12
	ext	0x1fdf		; 	xand	%r10,%r10,0xfffff7ff
	and	%r10,0x3f
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	ld.w	%r10,%r12
	ext	0x20		; 	xoor	%r10,%r10,0x00000800
	or	%r10,0x0
	add	%r10,%r11
	jp	__LX83		; 	xjp	__L83
__LX72:				; __L72:
	ld.w	%r10,%r12
	ext	0x1fef		; 	xand	%r10,%r10,0xfffffbff
	and	%r10,0x3f
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	ld.w	%r10,%r12
	ext	0x10		; 	xoor	%r10,%r10,0x00000400
	or	%r10,0x0
	add	%r10,%r11
	jp	__LX83		; 	xjp	__L83
__LX71:				; __L71:
	ext	0xfb		; 	xcmp	%r12,16127
	cmp	%r12,0x3f
	jrle	__LX70		; 	xjrle	__L70
	ext	0xfc		; 	xcmp	%r12,16143
	cmp	%r12,0xf
	jrgt	__LX77		; 	xjrgt	__L77
	ld.w	%r14,%r12
	add	%r14,%r11
	ld.w	%r11,%r14
	ld.b	[%r11],%r13	; 	xld.b	[%r11],%r13
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	jrne	__LX70		; 	xjrne	__L70
	ext	0x10		; 	xld.b	[%r11+16],%r13
	ld.b	[%r11],%r13
	jp	__LX70		; 	xjp	__L70
__LX77:				; __L77:
	ext	0xfc		; 	xcmp	%r12,16159
	cmp	%r12,0x1f
	jrgt	__LX70		; 	xjrgt	__L70
	ld.w	%r14,%r12
	add	%r14,%r11
	ld.w	%r11,%r14
	ld.b	[%r11],%r13	; 	xld.b	[%r11],%r13
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	jrne	__LX70		; 	xjrne	__L70
	ext	0x10		; 	xsub	%r10,%r11,16
	sub	%r10,%r11
__LX83:				; __L83:
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
__LX70:				; __L70:
	ret
	.align	1
	.global	ppu_draw_bg
ppu_draw_bg:
;	.frame	%sp,52,$31		# vars= 32, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x8		; 	xsub	%sp,%sp,32
	ext	ppu_vram+0x0@h	; 	xld.w	%r7,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r7,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r6,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r6,[%r8]
	ld.w	[%sp+0x0],%r6	; 	xld.w	[%sp],%r6
	ext	ppu+0xb@ah	; 	xld.ub	%r6,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r6,[%r8]
	ld.w	[%sp+0x1],%r6	; 	xld.w	[%sp+4],%r6
	ext	ppu+0x0@ah	; 	xld.ub	%r10,[ppu]
	ext	ppu+0x0@al
	ld.ub	%r10,[%r8]
	ld.w	%r11,%r10
	and	%r11,0x10	; 	xand	%r11,%r11,0x00000010
	sll	%r11,0x4	; 	xsll	%r11,4
	ld.w	[%sp+0x2],%r11	; 	xld.w	[%sp+8],%r11
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	sll	%r10,0x8	; 	xsll	%r10,10
	sll	%r10,0x2
	ld.w	%r2,%r10
	ext	0x80		; 	xoor	%r2,%r2,0x00002000
	or	%r2,0x0
	ext	ppu+0x4@ah	; 	xld.uh	%r3,[ppu+4]
	ext	ppu+0x4@al
	ld.uh	%r3,[%r8]
	ld.ub	%r4,%r3
	sra	%r3,0x8		; 	xsra	%r3,8
	ext	0x3		; 	xcmp	%r4,239
	cmp	%r4,0x2f
	jrle	__LX85		; 	xjrle	__L85
	ext	0x20		; 	xxor	%r2,%r2,0x00000800
	xor	%r2,0x0
	sub	%r4,0x10	; 	xsub	%r4,%r4,16
__LX85:				; __L85:
	ld.w	%r0,%r3
	sra	%r0,0x3		; 	xsra	%r0,3
	ld.w	%r1,%r4
	sra	%r1,0x3		; 	xsra	%r1,3
	ld.w	%r10,%r3
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	not	%r3,%r10
	add	%r3,1
	ld.w	%r10,%r4
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	not	%r4,%r10
	add	%r4,1
__LX86:				; __L86:
	ld.w	%r10,[%sp+0x0]	; 	xld.w	%r10,[%sp]
	sub	%r10,0x8	; 	xsub	%r10,%r10,8
	cmp	%r4,%r10
	jrle	__LX89		; 	xjrle	__L89
	ext	0x0		; 	xld.w	%r5,0x00000021		; 33
	ld.w	%r5,0x21
	ld.w	%r10,%r1
	and	%r10,0x3c	; 	xand	%r10,%r10,0xfffffffc
	sll	%r10,0x1	; 	xsll	%r10,1
	ext	0xf		; 	xoor	%r10,%r10,0x000003c0
	or	%r10,0x0
	ld.w	[%sp+0x7],%r10	; 	xld.w	[%sp+28],%r10
__LX90:				; __L90:
	ld.w	%r10,%r1
	sll	%r10,0x5	; 	xsll	%r10,5
	ld.w	%r6,%r2
	or	%r6,%r10
	ld.w	%r10,%r6
	or	%r10,%r0
	ld.w	%r6,%r7
	add	%r6,%r10
	ld.w	%r10,%r6
	ld.ub	%r14,[%r10]	; 	xld.ub	%r14,[%r10]
	ld.w	%r10,%r2
	ld.w	%r6,[%sp+0x7]	; 	xld.w	%r6,[%sp+28]
	or	%r10,%r6
	ld.w	%r11,%r0
	sra	%r11,0x2	; 	xsra	%r11,2
	or	%r10,%r11
	ld.w	%r6,%r7
	add	%r6,%r10
	ld.w	%r10,%r6
	ld.ub	%r15,[%r10]	; 	xld.ub	%r15,[%r10]
	ld.w	%r11,%r0
	and	%r11,0x2	; 	xand	%r11,%r11,0x00000002
	ld.w	%r10,%r1
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	sll	%r10,0x1	; 	xsll	%r10,1
	or	%r11,%r10
	ld.w	%r9,%r11	; 	xsra	%r15,%r11
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sra	%r15,0x8
	jp.d	-3
	sub	%r9,0x8
	sra	%r15,%r9
	ld.w	%r12,%r3
	ld.w	%r13,%r4
	ld.w	%r6,[%sp+0x2]	; 	xld.w	%r6,[%sp+8]
	or	%r14,%r6
	and	%r15,0x3	; 	xand	%r15,%r15,0x00000003
	ld.w	[%sp+0x3],%r4	; 	xld.w	[%sp+12],%r4
	ld.w	[%sp+0x4],%r5	; 	xld.w	[%sp+16],%r5
	ld.w	[%sp+0x6],%r7	; 	xld.w	[%sp+24],%r7
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	add	%r3,0x8		; 	xadd	%r3,%r3,8
	add	%r0,0x1		; 	xadd	%r0,%r0,1
	ld.w	%r4,[%sp+0x3]	; 	xld.w	%r4,[%sp+12]
	ld.w	%r5,[%sp+0x4]	; 	xld.w	%r5,[%sp+16]
	ld.w	%r7,[%sp+0x6]	; 	xld.w	%r7,[%sp+24]
	cmp	%r0,0x1f	; 	xcmp	%r0,31
	jrle	__LX92		; 	xjrle	__L92
	sub	%r0,0x20	; 	xsub	%r0,%r0,32
	ext	0x10		; 	xxor	%r2,%r2,0x00000400
	xor	%r2,0x0
__LX92:				; __L92:
	sub	%r5,0x1		; 	xsub	%r5,%r5,1
	jrne	__LX90		; 	xjrne	__L90
	ext	0x4		; 	xsub	%r3,%r3,264
	sub	%r3,0x8
	add	%r0,0x1f	; 	xadd	%r0,%r0,31
	cmp	%r0,0x1f	; 	xcmp	%r0,31
	jrle	__LX89		; 	xjrle	__L89
	sub	%r0,0x20	; 	xsub	%r0,%r0,32
	ext	0x10		; 	xxor	%r2,%r2,0x00000400
	xor	%r2,0x0
__LX89:				; __L89:
	add	%r4,0x8		; 	xadd	%r4,%r4,8
	add	%r1,0x1		; 	xadd	%r1,%r1,1
	cmp	%r1,0x1d	; 	xcmp	%r1,29
	jrle	__LX88		; 	xjrle	__L88
	sub	%r1,0x1e	; 	xsub	%r1,%r1,30
	ext	0x20		; 	xxor	%r2,%r2,0x00000800
	xor	%r2,0x0
__LX88:				; __L88:
	ld.w	%r6,[%sp+0x1]	; 	xld.w	%r6,[%sp+4]
	cmp	%r4,%r6
	jrlt	__LX86		; 	xjrlt	__L86
	add	%sp,0x8		; 	xadd	%sp,%sp,32
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_sprite
ppu_draw_sprite:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu+0x0@ah	; 	xbtst	[ppu],0x5
	ext	ppu+0x0@al
	btst	[%r8],0x5
	jreq	__LX99		; 	xjreq	__L99
	call	ppu_draw_sprite_8x16	; 	xcall	ppu_draw_sprite_8x16
	jp	__LX100		; 	xjp	__L100
__LX99:				; __L99:
	call	ppu_draw_sprite_8x8	; 	xcall	ppu_draw_sprite_8x8
__LX100:				; __L100:
	ret
	.align	1
	.global	ppu_draw_sprite_8x8
ppu_draw_sprite_8x8:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_sprram+0xfc@h	; 	xld.w	%r1,ppu_sprram+252
	ext	ppu_sprram+0xfc@m
	ld.w	%r1,ppu_sprram+0xfc@l
	ext	ppu+0x0@ah	; 	xld.ub	%r10,[ppu]
	ext	ppu+0x0@al
	ld.ub	%r10,[%r8]
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	ld.w	%r3,%r10
	sll	%r3,0x5		; 	xsll	%r3,5
	ld.w	%r2,%r12
	sll	%r2,0x5		; 	xsll	%r2,5
	ext	0x1		; 	xld.w	%r0,0x00000040		; 64
	ld.w	%r0,0x0
__LX102:				; __L102:
	ld.w	%r12,[%r1]	; 	xld.w	%r12,[%r1]
	sub	%r1,0x4		; 	xsub	%r1,%r1,4
	ld.ub	%r13,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r14,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r11,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r12,%r12
	ld.w	%r10,%r11
	xor	%r10,%r2
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jrne	__LX104		; 	xjrne	__L104
	ext	0x1		; 	xadd	%r10,%r13,1
	add	%r10,%r13
	ld.ub	%r13,%r10
	ext	0x3		; 	xcmp	%r13,239
	cmp	%r13,0x2f
	jrle	__LX106		; 	xjrle	__L106
	ld.b	%r13,%r13
__LX106:				; __L106:
	or	%r14,%r3
	ld.w	%r10,%r11
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	ld.w	%r15,%r10
	or	%r15,0x4	; 	xoor	%r15,%r15,0x00000004
	ld.w	%r10,%r11
	sra	%r10,0x6	; 	xsra	%r10,6
	cmp	%r10,0x2	; 	xcmp	%r10,2
	jreq	__LX110		; 	xjreq	__L110
	jrgt	__LX113		; 	xjrgt	__L113
	cmp	%r10,0x1	; 	xcmp	%r10,1
	jreq	__LX109		; 	xjreq	__L109
	jp	__LX108		; 	xjp	__L108
__LX113:				; __L113:
	cmp	%r10,0x3	; 	xcmp	%r10,3
	jreq	__LX111		; 	xjreq	__L111
__LX108:				; __L108:
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	jp	__LX104		; 	xjp	__L104
__LX109:				; __L109:
	ext	ppu_draw_chr_revx@rm	; 	xcall	ppu_draw_chr_revx
	call	ppu_draw_chr_revx@rl
	jp	__LX104		; 	xjp	__L104
__LX110:				; __L110:
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	jp	__LX104		; 	xjp	__L104
__LX111:				; __L111:
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
__LX104:				; __L104:
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
	jrne	__LX102		; 	xjrne	__L102
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_sprite_8x16
ppu_draw_sprite_8x16:
;	.frame	%sp,32,$31		# vars= 12, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x3		; 	xsub	%sp,%sp,12
	ext	ppu_sprram+0xfc@h	; 	xld.w	%r4,ppu_sprram+252
	ext	ppu_sprram+0xfc@m
	ld.w	%r4,ppu_sprram+0xfc@l
	ld.w	[%sp+0x1],%r4	; 	xld.w	[%sp+4],%r4
	sll	%r12,0x5	; 	xsll	%r12,5
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ext	0x1		; 	xld.w	%r4,0x00000040		; 64
	ld.w	%r4,0x0
	ld.w	[%sp+0x2],%r4	; 	xld.w	[%sp+8],%r4
__LX116:				; __L116:
	ld.w	%r4,[%sp+0x1]	; 	xld.w	%r4,[%sp+4]
	ld.w	%r0,[%r4]	; 	xld.w	%r0,[%r4]
	sub	%r4,0x4		; 	xsub	%r4,%r4,4
	ld.w	[%sp+0x1],%r4	; 	xld.w	[%sp+4],%r4
	ld.ub	%r2,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r1,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r12,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r0,%r0
	ld.w	%r10,%r12
	ld.w	%r4,[%sp+0x0]	; 	xld.w	%r4,[%sp]
	xor	%r10,%r4
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jrne	__LX118		; 	xjrne	__L118
	add	%r2,0x1		; 	xadd	%r2,%r2,1
	ld.w	%r10,%r1
	and	%r10,0x3e	; 	xand	%r10,%r10,0xfffffffe
	ld.w	%r11,%r1
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	sll	%r11,0x8	; 	xsll	%r11,8
	ld.w	%r1,%r10
	or	%r1,%r11
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	ld.w	%r3,%r10
	or	%r3,0x4		; 	xoor	%r3,%r3,0x00000004
	ld.w	%r10,%r12
	sra	%r10,0x6	; 	xsra	%r10,6
	cmp	%r10,0x2	; 	xcmp	%r10,2
	jreq	__LX123		; 	xjreq	__L123
	jrgt	__LX126		; 	xjrgt	__L126
	cmp	%r10,0x1	; 	xcmp	%r10,1
	jreq	__LX122		; 	xjreq	__L122
	jp	__LX121		; 	xjp	__L121
__LX126:				; __L126:
	cmp	%r10,0x3	; 	xcmp	%r10,3
	jreq	__LX124		; 	xjreq	__L124
__LX121:				; __L121:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	jp	__LX118		; 	xjp	__L118
__LX122:				; __L122:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	call	ppu_draw_chr_revx	; 	xcall	ppu_draw_chr_revx
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	call	ppu_draw_chr_revx	; 	xcall	ppu_draw_chr_revx
	jp	__LX118		; 	xjp	__L118
__LX123:				; __L123:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	jp	__LX118		; 	xjp	__L118
__LX124:				; __L124:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
__LX118:				; __L118:
	ld.w	%r4,[%sp+0x2]	; 	xld.w	%r4,[%sp+8]
	sub	%r4,0x1		; 	xsub	%r4,%r4,1
	ld.w	[%sp+0x2],%r4	; 	xld.w	[%sp+8],%r4
	jrne	__LX116		; 	xjrne	__L116
	add	%sp,0x3		; 	xadd	%sp,%sp,12
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_chr_revx
ppu_draw_chr_revx:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r2,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r2,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	ext	ppu+0xc@ah	; 	xld.w	%r5,[ppu+12]
	ext	ppu+0xc@al
	ld.w	%r5,[%r8]
	ext	ppu+0x10@h	; 	xld.w	%r0,ppu+16
	ext	ppu+0x10@m
	ld.w	%r0,ppu+0x10@l
	ext	0x8		; 	xsub	%r10,%r2,8
	sub	%r10,%r2
	cmp	%r13,%r10
	jrle	__LX128		; 	xjrle	__L128
	cmp	%r13,%r1
	jrge	__LX128		; 	xjrge	__L128
	ext	0x7		; 	xadd	%r10,%r12,7
	add	%r10,%r12
	ext	0x4		; 	xcmp	%r10,262
	cmp	%r10,0x6
	jrugt	__LX128		; 	xjrugt	__L128
	ld.w	%r10,%r13
	sll	%r10,0x8	; 	xsll	%r10,8
	add	%r10,%r12
	add	%r5,%r10
	ld.w	%r10,%r15
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r10,%r0
	ld.w	%r0,%r10
	ld.w	%r10,%r14
	sll	%r10,0x4	; 	xsll	%r10,4
	ld.w	%r6,%r10
	add	%r6,%r11
	cmp	%r13,%r2
	jrlt	__LX131		; 	xjrlt	__L131
	ext	0x8		; 	xsub	%r10,%r1,8
	sub	%r10,%r1
	cmp	%r13,%r10
	jrgt	__LX131		; 	xjrgt	__L131
	ext	0x3		; 	xld.w	%r10,0x000000f8		; 248
	ld.w	%r10,0x38
	cmp	%r12,%r10
	jrugt	__LX131		; 	xjrugt	__L131
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ld.w	%r12,%r10
__LX132:				; __L132:
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX135:				; __L135:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX138		; 	xjreq	__L138
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX138:				; __L138:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX135		; 	xjrne	__L135
	add	%r5,%r12
	add	%r6,0x1		; 	xadd	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX132		; 	xjrne	__L132
	jp	__LX128		; 	xjp	__L128
__LX131:				; __L131:
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ext	0x3		; 	xld.w	%r3,0x000000ff		; 255
	ld.w	%r3,0x3f
__LX142:				; __L142:
	cmp	%r13,%r2
	jrlt	__LX145		; 	xjrlt	__L145
	cmp	%r13,%r1
	jrge	__LX145		; 	xjrge	__L145
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX146:				; __L146:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX149		; 	xjreq	__L149
	cmp	%r12,%r3
	jrugt	__LX149		; 	xjrugt	__L149
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX149:				; __L149:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX146		; 	xjrne	__L146
	sub	%r12,0x8	; 	xsub	%r12,%r12,8
	sub	%r5,0x8		; 	xsub	%r5,%r5,8
__LX145:				; __L145:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ext	0x4		; 	xadd	%r5,%r5,256
	add	%r5,0x0
	add	%r6,0x1		; 	xadd	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX142		; 	xjrne	__L142
__LX128:				; __L128:
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_chr_revy
ppu_draw_chr_revy:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r2,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r2,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	ext	ppu+0xc@ah	; 	xld.w	%r5,[ppu+12]
	ext	ppu+0xc@al
	ld.w	%r5,[%r8]
	ext	ppu+0x10@h	; 	xld.w	%r0,ppu+16
	ext	ppu+0x10@m
	ld.w	%r0,ppu+0x10@l
	ext	0x8		; 	xsub	%r10,%r2,8
	sub	%r10,%r2
	cmp	%r13,%r10
	jrle	__LX153		; 	xjrle	__L153
	cmp	%r13,%r1
	jrge	__LX153		; 	xjrge	__L153
	ext	0x7		; 	xadd	%r10,%r12,7
	add	%r10,%r12
	ext	0x4		; 	xcmp	%r10,262
	cmp	%r10,0x6
	jrugt	__LX153		; 	xjrugt	__L153
	ld.w	%r10,%r13
	sll	%r10,0x8	; 	xsll	%r10,8
	add	%r10,%r12
	add	%r5,%r10
	ld.w	%r10,%r15
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r10,%r0
	ld.w	%r0,%r10
	ld.w	%r10,%r14
	sll	%r10,0x4	; 	xsll	%r10,4
	or	%r10,0x7	; 	xoor	%r10,%r10,0x00000007
	ld.w	%r6,%r10
	add	%r6,%r11
	cmp	%r13,%r2
	jrlt	__LX156		; 	xjrlt	__L156
	ext	0x8		; 	xsub	%r10,%r1,8
	sub	%r10,%r1
	cmp	%r13,%r10
	jrgt	__LX156		; 	xjrgt	__L156
	ext	0x3		; 	xld.w	%r10,0x000000f8		; 248
	ld.w	%r10,0x38
	cmp	%r12,%r10
	jrugt	__LX156		; 	xjrugt	__L156
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ld.w	%r12,%r10
__LX157:				; __L157:
	ld.ub	%r10,[%r6]	; 	xld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r4,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r4,[%r9]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r10,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX160:				; __L160:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX163		; 	xjreq	__L163
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX163:				; __L163:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX160		; 	xjrne	__L160
	add	%r5,%r12
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX157		; 	xjrne	__L157
	jp	__LX153		; 	xjp	__L153
__LX156:				; __L156:
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ext	0x3		; 	xld.w	%r3,0x000000ff		; 255
	ld.w	%r3,0x3f
__LX167:				; __L167:
	cmp	%r13,%r2
	jrlt	__LX170		; 	xjrlt	__L170
	cmp	%r13,%r1
	jrge	__LX170		; 	xjrge	__L170
	ld.ub	%r10,[%r6]	; 	xld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r4,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r4,[%r9]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ext	mirror_table+0x0@h	; 	xld.ub	%r10,[%r10+mirror_table]
	ext	mirror_table+0x0@m
	ld.w	%r9,mirror_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX171:				; __L171:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX174		; 	xjreq	__L174
	cmp	%r12,%r3
	jrugt	__LX174		; 	xjrugt	__L174
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX174:				; __L174:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX171		; 	xjrne	__L171
	sub	%r12,0x8	; 	xsub	%r12,%r12,8
	sub	%r5,0x8		; 	xsub	%r5,%r5,8
__LX170:				; __L170:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ext	0x4		; 	xadd	%r5,%r5,256
	add	%r5,0x0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX167		; 	xjrne	__L167
__LX153:				; __L153:
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_chr_revxy
ppu_draw_chr_revxy:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	ppu+0xa@ah	; 	xld.ub	%r2,[ppu+10]
	ext	ppu+0xa@al
	ld.ub	%r2,[%r8]
	ext	ppu+0xb@ah	; 	xld.ub	%r1,[ppu+11]
	ext	ppu+0xb@al
	ld.ub	%r1,[%r8]
	ext	ppu+0xc@ah	; 	xld.w	%r5,[ppu+12]
	ext	ppu+0xc@al
	ld.w	%r5,[%r8]
	ext	ppu+0x10@h	; 	xld.w	%r0,ppu+16
	ext	ppu+0x10@m
	ld.w	%r0,ppu+0x10@l
	ext	0x8		; 	xsub	%r10,%r2,8
	sub	%r10,%r2
	cmp	%r13,%r10
	jrle	__LX178		; 	xjrle	__L178
	cmp	%r13,%r1
	jrge	__LX178		; 	xjrge	__L178
	ext	0x7		; 	xadd	%r10,%r12,7
	add	%r10,%r12
	ext	0x4		; 	xcmp	%r10,262
	cmp	%r10,0x6
	jrugt	__LX178		; 	xjrugt	__L178
	ld.w	%r10,%r13
	sll	%r10,0x8	; 	xsll	%r10,8
	add	%r10,%r12
	add	%r5,%r10
	ld.w	%r10,%r15
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r10,%r0
	ld.w	%r0,%r10
	ld.w	%r10,%r14
	sll	%r10,0x4	; 	xsll	%r10,4
	or	%r10,0x7	; 	xoor	%r10,%r10,0x00000007
	ld.w	%r6,%r10
	add	%r6,%r11
	cmp	%r13,%r2
	jrlt	__LX181		; 	xjrlt	__L181
	ext	0x8		; 	xsub	%r10,%r1,8
	sub	%r10,%r1
	cmp	%r13,%r10
	jrgt	__LX181		; 	xjrgt	__L181
	ext	0x3		; 	xld.w	%r10,0x000000f8		; 248
	ld.w	%r10,0x38
	cmp	%r12,%r10
	jrugt	__LX181		; 	xjrugt	__L181
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ld.w	%r12,%r10
__LX182:				; __L182:
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX185:				; __L185:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX188		; 	xjreq	__L188
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX188:				; __L188:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX185		; 	xjrne	__L185
	add	%r5,%r12
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX182		; 	xjrne	__L182
	jp	__LX178		; 	xjp	__L178
__LX181:				; __L181:
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
	ext	0x3		; 	xld.w	%r3,0x000000ff		; 255
	ld.w	%r3,0x3f
__LX192:				; __L192:
	cmp	%r13,%r2
	jrlt	__LX195		; 	xjrlt	__L195
	cmp	%r13,%r1
	jrge	__LX195		; 	xjrge	__L195
	ld.ub	%r4,[%r6]	; 	xld.ub	%r4,[%r6]
	ext	0x8		; 	xld.ub	%r10,[%r6+8]
	ld.ub	%r10,[%r6]
	ld.w	%r15,%r10
	sll	%r15,0x1	; 	xsll	%r15,1
	ld.w	%r14,0x8	; 	xld.w	%r14,0x00000008		; 8
__LX196:				; __L196:
	ld.w	%r11,%r4
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	or	%r11,%r10
	jreq	__LX199		; 	xjreq	__L199
	cmp	%r12,%r3
	jrugt	__LX199		; 	xjrugt	__L199
	ld.w	%r10,%r0
	add	%r10,%r11
	ld.ub	%r10,[%r10]	; 	xld.ub	%r10,[%r10]
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
__LX199:				; __L199:
	sra	%r4,0x1		; 	xsra	%r4,1
	sra	%r15,0x1	; 	xsra	%r15,1
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	sub	%r14,0x1	; 	xsub	%r14,%r14,1
	jrne	__LX196		; 	xjrne	__L196
	sub	%r12,0x8	; 	xsub	%r12,%r12,8
	sub	%r5,0x8		; 	xsub	%r5,%r5,8
__LX195:				; __L195:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ext	0x4		; 	xadd	%r5,%r5,256
	add	%r5,0x0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX192		; 	xjrne	__L192
__LX178:				; __L178:
	popn	%r3
	ret

	.comm	ppu 48

	.comm	ppu_vram 16384

	.comm	ppu_sprram 256

